package shockes.burj;

import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Typeface;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.TextView;

import com.metaio.sdk.MetaioDebug;
import com.metaio.sdk.SensorsComponentAndroid;
import com.metaio.sdk.jni.IBillboardGroup;
import com.metaio.sdk.jni.IGeometry;
import com.metaio.sdk.jni.IMetaioSDKCallback;
import com.metaio.sdk.jni.IRadar;
import com.metaio.sdk.jni.LLACoordinate;
import com.metaio.sdk.jni.TrackingValues;
import com.metaio.sdk.jni.TrackingValuesVector;
import com.metaio.sdk.jni.Vector3d;
import com.metaio.tools.io.AssetsManager;



public class LLACore extends MetaioSDKViewActivity implements SensorsComponentAndroid.Callback{

	/**
	 * Geometries
	 */
//	private IGeometry mGeometrySouth;
//	private IGeometry mGeometryWest;
//	private IGeometry mGeometryNorth;
	IGeometry mMyPOI;
	private boolean bMyPOI=false;
	private IGeometry mImagePlane;
	private IGeometry mTransparentPlane;
	private boolean bImagePlane=false;
	private TextView mText;
	
	private boolean targeted= false;
	private LLACoordinate myTarget= new LLACoordinate(0, 0,0, 0);
	private String ISBAN=null;
	private BookData myBookData;
	
	
	private IBillboardGroup g;
	
	
	private IRadar mRadar;

	/**
	 * Offset from current location
	 */
	private static final double OFFSET = 		0.00002;
	
	@Override
	public void onCreate(Bundle savedInstanceState) 
	{
		super.onCreate(savedInstanceState);
		
		//Get Book Data
		ISBAN=getIntent().getStringExtra("ISBAN");
		BookDataBase BD = new BookDataBase();
		myBookData = BD.checkBookDataBaseBestMatching(ISBAN);
		
		//SDK setting
		metaioSDK.setLLAObjectRenderingLimits(10, 10000);
		g = metaioSDK.createBillboardGroup(800, 800);	
		
		//Set Tracking configuration
		boolean result = metaioSDK.setTrackingConfiguration("LLA");  
		MetaioDebug.log("Tracking data loaded: " + result);
		
		mText = new TextView(this);
	    mGUIView = mText;
	}
	
	@Override
	protected void onPause() 
	{
		super.onPause();
		
		// remove callback
		if (mSensors != null)
		{
			mSensors.registerCallback(null);
		//	mSensorsManager.pause();
		}
		
		
	}

	@Override
	protected void onResume() 
	{
		super.onResume();

		// Register callback to receive sensor updates
		if (mSensors != null)
		{
			mSensors.registerCallback(this);
			//mSensorsManager.resume();
		}
		
	}


	@Override
	public void onLocationSensorChanged(LLACoordinate location)
	{
		if(targeted)
			updateGeometriesLocation(location);
	}


	public void onButtonClick(View v)
	{
		finish();
	}

	@Override
	protected int getGUILayout() 
	{
		return R.layout.llalayout;
	}

	@Override
	protected void loadContent() 
	{
		String[] sd;
		
		try {
			sd = this.getAssets().list("ex");
			for (int i=0; i < sd.length; i++)
				Log.i("getAssets", sd[i]);
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		
		if (targeted)
		{
			try
			{ 
				AssetsManager.extractAllAssets(getApplicationContext(),"ex",true);
				
				String filepath = AssetsManager.getAssetPath("ex/POI_bg.png");
				if (filepath != null) 
				{
					
					//mMyPOI=metaioSDK.createGeometryFromImage(filepath, true);
					bMyPOI=true;
					mMyPOI = metaioSDK.loadImageBillboard(createBillboardTexture("Tu libro"));//    ));//"BAR"));
					bMyPOI=false;
					//mMyPOI.setRelativeToScreen(IGeometry.ANCHOR_NONE, IGeometry.FLAG_IGNORE_ROTATION);
				}	
				
				
				String imagePath = AssetsManager.getAssetPath("ex/pie_localizacion.png");
				if (filepath != null) 
				{
					bImagePlane=true;	
					mImagePlane = metaioSDK.createGeometryFromImage(imagePath);
					mTransparentPlane = metaioSDK.createGeometryFromImage(createBillboardTexture("Estanteria: " + myBookData.getEstanteria() + "\nOrientacin: " + getOrientation(myBookData.getOrientation()) + "\nColor: " + getColor(myBookData.getColor()) + "\nCDU: " + ISBAN   ));
					
					if(mImagePlane != null && mTransparentPlane != null)
					{
						bImagePlane=true;
						mImagePlane.setRelativeToScreen(IGeometry.ANCHOR_BOTTOM, IGeometry.FLAG_MATCH_DISPLAY );
						mTransparentPlane.setRelativeToScreen(IGeometry.ANCHOR_BOTTOM, IGeometry.FLAG_MATCH_DISPLAY);
						mImagePlane.setVisible(true);
						mTransparentPlane.setVisible(true);
						g.addBillboard(mImagePlane);
						g.addBillboard(mTransparentPlane);
							
						bImagePlane=false;
						
					}
				}	
				switch(myBookData.getEstanteria())
				{
					case 1:
						myTarget.setLatitude(40.281048);
						myTarget.setLongitude(-3.81988);
						myTarget.setAltitude(664);
						break;
					case 2:
						myTarget.setLatitude(40.281149);
						myTarget.setLongitude(-3.819887);
						myTarget.setAltitude(664);
						break;
					case 3:
						myTarget.setLatitude(40.281149);
						myTarget.setLongitude(-3.819911);
						myTarget.setAltitude(664);
						break;
					case 4:
						myTarget.setLatitude(40.281149);
						myTarget.setLongitude(-3.819953);
						myTarget.setAltitude(664);
						break;
					case 5:
						myTarget.setLatitude(40.281149);
						myTarget.setLongitude(-3.819980);
						myTarget.setAltitude(664);
						break;
					case 6:
						myTarget.setLatitude(40.281149);
						myTarget.setLongitude(-3.820005);
						myTarget.setAltitude(664);
						break;
					case 7:
						myTarget.setLatitude(40.281171);
						myTarget.setLongitude(-3.820009);
						myTarget.setAltitude(664);
						break;
					case 8:
						myTarget.setLatitude(40.281171);
						myTarget.setLongitude(-3.820042);
						break;
					case 9:
						myTarget.setLatitude(40.281232);
						myTarget.setLongitude(-3.820043);
						myTarget.setAltitude(664);
						break;
					case 10:
						myTarget.setLatitude(40.281316);
						myTarget.setLongitude(-3.819955);
						myTarget.setAltitude(664);
						break;
					case 11:
						myTarget.setLatitude(40.281315);
						myTarget.setLongitude(-3.819929);
						myTarget.setAltitude(664);
						break;
					case 12:
						myTarget.setLatitude(40.281314);
						myTarget.setLongitude(-3.819903);
						myTarget.setAltitude(664);
						break;
					case 13:
						myTarget.setLatitude(40.281314);
						myTarget.setLongitude(-3.819877);
						myTarget.setAltitude(664);
						break;
					case 14:
						myTarget.setLatitude(40.281314);
						myTarget.setLongitude(-3.819851);
						myTarget.setAltitude(664);
						break;
					case 15:
						myTarget.setLatitude(40.281315);
						myTarget.setLongitude(-3.819824);
						myTarget.setAltitude(664);
						break;
					case 16:
						myTarget.setLatitude(40.281356);
						myTarget.setLongitude(-3.819798);
						myTarget.setAltitude(664);
						break;
					case 17:
						myTarget.setLatitude(40.281356);
						myTarget.setLongitude(-3.819772);
						myTarget.setAltitude(664);
						break;
				
				}
				
				myTarget.setAccuracy(10);
				mMyPOI.setTranslationLLA(myTarget);
				g.addBillboard(mMyPOI);	
//				}else{
//					try 
//					{
//						AssetsManager.extractAllAssets(getApplicationContext(), true);
//						mGeometrySouth = metaioSDK.loadImageBillboard(createBillboardTexture("South"));
//						mGeometryNorth = metaioSDK.loadImageBillboard(createBillboardTexture("North"));
//						mMyPOI=metaioSDK.loadImageBillboard(createBillboardTexture("BAR"));
//					} 
//					catch (IOException e) 
//					{
//						
//					}
//					
//				}
				
				/*filepath = AssetsManager.getAssetPath("ex/metaioman.md2");
				if (filepath != null) 
				{
					// West
					mGeometryWest = metaioSDK.createGeometry(filepath);
					if (mGeometryWest != null)
					{
						mGeometryWest.startAnimation("idle", true);
						mGeometryWest.setScale(new Vector3d(4f,4f,4f));
					}
				
				}*/
				
				//updateGeometriesLocation(mSensors.getLocation());
				
				// create radar
				mRadar = metaioSDK.createRadar();
				mRadar.setBackgroundTexture(AssetsManager.getAssetPath("ex/radar.png"));
				mRadar.setObjectsDefaultTexture(AssetsManager.getAssetPath("ex/yellow.png"));
				mRadar.setRelativeToScreen(IGeometry.ANCHOR_TL);
			
				mRadar.add(mMyPOI);
				//displayText("Estanteria: " + myBookData.getEstanteria() + "\nOrientacin: " + myBookData.getOrientation() + "\nColor: " + myBookData.getColor() + "\nCDU: " + ISBAN       );
				
			}
			
			catch (Exception e)
			{
				Log.i("Cargando Radar", e.getMessage());
			}
			
	}
		
	}
	
	private String createBillboardTexture(String billBoardTitle)
    {
           try
           {
                  final String texturepath = getCacheDir() + "/" + billBoardTitle + ".png";
                  Paint mPaint = new Paint();

                  // Load background image (256x128), and make a mutable copy
                  Bitmap billboard = null;
                  String filepath="";
                  
                  //reading billboard background
                  if(bMyPOI)
                	  filepath = AssetsManager.getAssetPath("ex/POI_bg.png");
                  else if (bImagePlane)
                	  filepath = AssetsManager.getAssetPath("ex/pie_transparent.png");
                  
                  Bitmap mBackgroundImage = BitmapFactory.decodeFile(filepath);
                  
                  billboard = mBackgroundImage.copy(Bitmap.Config.ARGB_8888, true);


                  Canvas c = new Canvas(billboard);

                  if(bMyPOI)
                  {
	                  mPaint.setColor(Color.WHITE);
	                  mPaint.setTextSize(24);
	                  mPaint.setTypeface(Typeface.DEFAULT);
                  }else if(bImagePlane)
                  {
	            	  mPaint.setColor(Color.BLACK);
	                  mPaint.setTextSize(24);
	                  mPaint.setTypeface(Typeface.DEFAULT);
                  }

                  float y = 30;
                  float x = 60;

                  // Draw POI name
                  if (billBoardTitle.length() > 0)
                  {
                        String n = billBoardTitle.trim();
                        int startIndex =0;
                        int offset=0;
                        
                        if(n.contains("\n"))
                        {
                        
                        do{
                        	
                        	startIndex = n.indexOf("\n");
                        	String aux=n.substring(0, startIndex);
                        	c.drawText(aux, x, y+offset, mPaint);
                        	n=n.substring(startIndex+1, n.length());
                        	offset=offset+30;
                        }while(n.contains("\n"));
                        
                        c.drawText(n, x, y+offset, mPaint);
                        
                        }else
                        {
                        	final int maxWidth = mBackgroundImage.getWidth()-5;
                        	int i = mPaint.breakText(n, true, maxWidth, null);
                        	c.drawText(n.substring(0, i), x, y, mPaint);
                        }

                        /*final int maxWidth = mBackgroundImage.getWidth()-5;//160;

                        int i = mPaint.breakText(n, true, maxWidth, null);
                        c.drawText(n.substring(0, i), x, y, mPaint);

                        // Draw second line if valid
                        if (i < n.length())
                        {
                               n = n.substring(i);
                               y += 20;
                               i = mPaint.breakText(n, true, maxWidth, null);

                               if (i < n.length())
                               {
                                      i = mPaint.breakText(n, true, maxWidth - 20, null);
                                      c.drawText(n.substring(0, i) + "...", x, y, mPaint);
                               } else
                               {
                                      c.drawText(n.substring(0, i), x, y, mPaint);
                               }
                        }*/

                  }


                  // writing file
                  try
                  {
                	  FileOutputStream out = new FileOutputStream(texturepath);
                      billboard.compress(Bitmap.CompressFormat.PNG, 90, out);
                      MetaioDebug.log("Texture file is saved to "+texturepath);
                      return texturepath;
                  } catch (Exception e) {
                      MetaioDebug.log("Failed to save texture file");
                	  e.printStackTrace();
                   }
                 
                  billboard.recycle();
                  billboard = null;

           } catch (Exception e)
           {
                  MetaioDebug.log("Error creating billboard texture: " + e.getMessage());
                  MetaioDebug.printStackTrace(Log.DEBUG, e);
                  return null;
           }
           return null;
    }
	
	private void updateGeometriesLocation(LLACoordinate location)
	{	
		
		if (mMyPOI != null)
		{

			switch(myBookData.getEstanteria())
			{
				case 1:
					myTarget.setLatitude(40.281149);
					myTarget.setLongitude(-3.819863);
					myTarget.setAltitude(664);
					break;
				case 2:
					myTarget.setLatitude(40.281149);
					myTarget.setLongitude(-3.819887);
					myTarget.setAltitude(664);
					break;
				case 3:
					myTarget.setLatitude(40.281149);
					myTarget.setLongitude(-3.819911);
					myTarget.setAltitude(664);
					break;
				case 4:
					myTarget.setLatitude(40.281149);
					myTarget.setLongitude(-3.819953);
					myTarget.setAltitude(664);
					break;
				case 5:
					myTarget.setLatitude(40.281149);
					myTarget.setLongitude(-3.819980);
					myTarget.setAltitude(664);
					break;
				case 6:
					myTarget.setLatitude(40.281149);
					myTarget.setLongitude(-3.820005);
					myTarget.setAltitude(664);
					break;
				case 7:
					myTarget.setLatitude(40.281171);
					myTarget.setLongitude(-3.820009);
					myTarget.setAltitude(664);
					break;
				case 8:
					myTarget.setLatitude(40.281171);
					myTarget.setLongitude(-3.820042);
					break;
				case 9:
					myTarget.setLatitude(40.281312);
					myTarget.setLongitude(-3.819973);
					myTarget.setAltitude(664);
					break;
				case 10:
					myTarget.setLatitude(40.281316);
					myTarget.setLongitude(-3.819955);
					myTarget.setAltitude(664);
					break;
				case 11:
					myTarget.setLatitude(40.281315);
					myTarget.setLongitude(-3.819929);
					myTarget.setAltitude(664);
					break;
				case 12:
					myTarget.setLatitude(40.281314);
					myTarget.setLongitude(-3.819903);
					myTarget.setAltitude(664);
					break;
				case 13:
					myTarget.setLatitude(40.281314);
					myTarget.setLongitude(-3.819877);
					myTarget.setAltitude(664);
					break;
				case 14:
					myTarget.setLatitude(40.281314);
					myTarget.setLongitude(-3.819851);
					myTarget.setAltitude(664);
					break;
				case 15:
					myTarget.setLatitude(40.281315);
					myTarget.setLongitude(-3.819824);
					myTarget.setAltitude(664);
					break;
				case 16:
					myTarget.setLatitude(40.281356);
					myTarget.setLongitude(-3.819798);
					myTarget.setAltitude(664);
					break;
				case 17:
					myTarget.setLatitude(40.281356);
					myTarget.setLongitude(-3.819772);
					myTarget.setAltitude(664);
					break;
			
			}
			
			myTarget.setAccuracy(10);
			mMyPOI.setTranslationLLA(myTarget);
			g.addBillboard(mMyPOI);			
			
		}	
		
	}
	
	@Override
	protected void onGeometryTouched(final IGeometry geometry) 
	{
		MetaioDebug.log("Geometry selected: "+geometry);
		
		mSurfaceView.queueEvent(new Runnable()
		{

			@Override
			public void run() 
			{
				mRadar.setObjectsDefaultTexture(AssetsManager.getAssetPath("ex/yellow.png"));
				mRadar.setObjectTexture(geometry, AssetsManager.getAssetPath("ex/red.png"));
			}
		
				
		});
	}

	@Override
	public void onGravitySensorChanged(float[] gravity) {
		// TODO Auto-generated method stub
		
	}
	
	 private void displayText(final String data)
	    {
	        runOnUiThread(new Runnable()
	        {
	            @Override
	            public void run() {

	                mText.setText(data);
	            }

	        });
	    }

	@Override
	public void onHeadingSensorChanged(float[] orientation) {
		// TODO Auto-generated method stub
		
	}
	
	@Override
    protected IMetaioSDKCallback getMetaioSDKCallbackHandler() 
    {
        return new MetaioSDKCallbackHandler();
    }
	
	
	String getOrientation(int orientation)
	{
		String sOrientation="";
		
		switch (orientation) {
			case 0:
				sOrientation="Izquierda";
				break;
			case 1:
				sOrientation="Derecha";
			break;
				
			default:
				break;
		}
		
		return sOrientation;
		
	}
	
	String getColor(int color)
	{
		String  sColor="";
		
		switch (color) {
		case 1:
			sColor="Amarillo";
			break;
		case 2:		
			sColor="Marrn";
			break;
		case 3:	
			sColor="Violeta";
			break;
		case 4:			
			sColor="Rojo";
			break;
		case 5:			
			sColor="Rosa";
			break;
		case 6:			
			sColor="Azul";
			break;
		case 7:			
			sColor="Naranaja";
			break;
		case 8:			
			sColor="Verde";
			break;
		case 9:			
			sColor="Cian";
			break;
		
		default:
			break;
		}
		
		
		return sColor;
	}
	 final class MetaioSDKCallbackHandler extends IMetaioSDKCallback
	    {       
	        @Override
	        public void onTrackingEvent(TrackingValuesVector trackingValues)
	        {
	            if (trackingValues.size() > 0)
	            {
	                final TrackingValues currentValues = trackingValues.get(0);
	                
	                if (currentValues.isTrackingState())
	                {   
	                    final String tokens = currentValues.getLlaCoordinate().toString();	                    
	                    
	                    if (!tokens.contains("0,")  && !targeted)
			            {
			            
			            	mSensors.setManualLocation(currentValues.getLlaCoordinate());
			                targeted=true;
			                loadContent();	                        
			                //displayText("QR Code detected: "+tokens+" Qr Code target: "+ myTarget.getLatitude() +","+ myTarget.getLongitude()+"," +myTarget.getAltitude());
			                //displayText("Estanteria: " + myBookData.getEstanteria() + "\nOrientacin: " + myBookData.getOrientation() + "\nColor: " + myBookData.getColor() + "\nCDU: " + ISBAN       );
			        
			            }
	//	                    else if(lastTokens != tokens && myTarget!=null)
	//	                    {
	//	                    	myTarget=currentValues.getLlaCoordinate();
	//	                    	lastValues = currentValues.getLlaCoordinate();
	//	                        displayText("QR Code detected: "+tokens);
	//	                        targeted=true;
	//	                        loadContent();
	//	                        displayText("QR Code detected: "+tokens+" Qr Code target: "+ myTarget.getLatitude() +","+ myTarget.getLongitude()+"," +myTarget.getAltitude());
	//	   
	//	                    }
	            }
	        }
	    }
	
	}

}

