package shockes.burj;

import android.net.ConnectivityManager;
import android.net.Uri;
import android.os.Bundle;
import android.app.AlertDialog;
import android.app.DownloadManager;
import android.app.ProgressDialog;
import android.app.DownloadManager.Request;
import android.content.Context;
import android.content.DialogInterface;
import android.graphics.Color;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup.LayoutParams;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;
import java.util.ArrayList;
import java.util.List;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import shockes.burj.htmlParser;
import android.support.v4.app.FragmentActivity;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.CameraPosition;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.MarkerOptions;

public class Pestana2 extends FragmentActivity {
	
	private GoogleMap mapView;
	private static final LatLng BIBLIOTECA = 
	        new LatLng(40.281195,-3.819818);
	
	//private static final int latitudeE6 = (int) (  * 1E6);
	//private static final int longitudeE6 = (int) ( * 1E6);
	private final Context context = this;
	public boolean loaded = false;
	private List<InfoNode> myFuenlaCategories = new ArrayList<InfoNode>();
	private List<InfoNode> myBurjCategories = new ArrayList<InfoNode>();
	private List<InfoNode> FAQs = new ArrayList<InfoNode>();
	private List<String> myFAQs = new ArrayList<String>();
	private List<String> myBurjRules = new ArrayList<String>();
	private List<String> myFuenlaRules = new ArrayList<String>();
	
	public class InfoNode{
		
		private String nombre = null;
		private String link = null;
		private List<String> titles = null;
		private List<String> entries = null;
		
		public void setNombre(String myNombre)
		{
			nombre=myNombre;
		}
		public void setLink(String myLink)
		{
			link=myLink;
		}
		public void setTitles(List<String> myTitles)
		{
			titles=myTitles;
		}
		public void setEntries(List<String> myEntries)
		{
			entries=myEntries;
		}
		
		public String getNombre()
		{
			return nombre;
		}
		
		public String getLink()
		{
			return link;
		}
		public List<String> getTitles()
		{
			return titles;
		}
		public List<String> getEntries()
		{
			return entries;
		}
	}
	
	
	
	@Override
	public void onCreate(Bundle savedInstanceState){
		super.onCreate(savedInstanceState);
		setContentView(R.layout.pestana2);
		
		
		
		//=================== Botones ==============================
		Button horarios = (Button) findViewById(R.id.btnHorarios);
		horarios.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
//				if(isNotUpdated())
//					updateTimetable();
				showHorarios(v);
				
			}

			
		});
		
		Button normativa = (Button) findViewById(R.id.btnNormativa);
		normativa.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				showInfoNode(v);
				
			}
		});
		
		Button FAQbtn = (Button) findViewById(R.id.btnFAQ);
		FAQbtn.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				showFAQ(v);
				
			}
		});
		
		Button mapa = (Button) findViewById(R.id.btnMapa);
		mapa.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				showMapa(v);
				
			}
		});
		
		Button btnFuenlabrada = (Button)findViewById(R.id.btnBibFuenl);
		btnFuenlabrada.setOnClickListener(new View.OnClickListener() {			
			public void onClick(View v) {
				showNormFuenlabrada();
				
			}
		});
		
		Button btnBurj = (Button)findViewById(R.id.btnBurjc);
		btnBurj.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				showNormBurj();
				
			}
		});
		
		Button faq0 = (Button)findViewById(R.id.btnFAQ0);
		faq0.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				showFAQ(0);
				
			}
		});
		
		Button faq1 = (Button)findViewById(R.id.btnFAQ1);
		faq1.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				showFAQ(1);
				
			}
		});
		
		Button faq2 = (Button)findViewById(R.id.btnFAQ2);
		faq2.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				showFAQ(2);
				
			}
		});
		
		Button faq3 = (Button)findViewById(R.id.btnFAQ3);
		faq3.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				showFAQ(3);
				
			}
		});
		Button faq4 = (Button)findViewById(R.id.btnFAQ4);
		faq4.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				showFAQ(4);
				
			}
		});
		Button faq5 = (Button)findViewById(R.id.btnFAQ5);
		faq5.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				showFAQ(5);
				
			}
		});
		Button faq6 = (Button)findViewById(R.id.btnFAQ6);
		faq6.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				showFAQ(6);
				
			}
		});
		Button faq7 = (Button)findViewById(R.id.btnFAQ7);
		faq7.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				showFAQ(7);
				
			}
		});
		Button faq8 = (Button)findViewById(R.id.btnFAQ8);
		faq8.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				showFAQ(8);
				
			}
		});
		
		//============== Loading Pestana2 data ======================
		if(!loaded)
			loadDataPestana2();
		
		//=================== Google maps ===========================
		mapView = ((SupportMapFragment) getSupportFragmentManager()
                .findFragmentById(R.id.map_view)).getMap();
		
		mapView.addMarker(new MarkerOptions()
		        .position(BIBLIOTECA)
		        .title("Biblioteca Universidad Rey Juan Carlos de Fuenlabrada")
		        .snippet("Camino del Molino s/n 28943 - Fuenlabrada")
		        .icon(BitmapDescriptorFactory
		        .fromResource(R.drawable.ic_launcher)));
		
		mapView.setMapType(GoogleMap.MAP_TYPE_HYBRID);
		
		CameraPosition cameraPosition = new CameraPosition.Builder()
			    .target(BIBLIOTECA)      // Sets the center of the Library
			    .zoom(16)                   // Sets the zoom
			    .build();                   // Creates a CameraPosition from the builder
		
		mapView.animateCamera(CameraUpdateFactory.newCameraPosition(cameraPosition));
		
		
	}
	
	@Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is 
        // present.
        getMenuInflater().inflate(R.menu.activity_main, menu);
        return true;
    }
	
	@Override
    public boolean onOptionsItemSelected(MenuItem item) {
 
        switch (item.getItemId()) {
 
        case R.id.menu_sethybrid:
            mapView.setMapType(GoogleMap.MAP_TYPE_HYBRID);
            break;
            
        case R.id.menu_zoomin:
        	mapView.animateCamera(CameraUpdateFactory.zoomIn());
            break;
 
        case R.id.menu_zoomout:
        	mapView.animateCamera(CameraUpdateFactory.zoomOut());
            break;
        case R.id.menu_addmarker:
        	 mapView.addMarker(new MarkerOptions()
                .position(BIBLIOTECA)
                .title("Biblioteca Universidad Rey Juan Carlos de Fuenlabrada")
                .snippet("Camino del Molino s/n 28943 - Fuenlabrada - Madrid")
                .icon(BitmapDescriptorFactory
                .fromResource(R.drawable.ic_launcher)));
            break;
        }
        return true;
    }
	
//	@Override
//	protected boolean isRouteDisplayed() {
//		return false;
//	}
	
	public void showHorarios(View view){
		LinearLayout horariosLayout = (LinearLayout) findViewById(R.id.horariosLayout);
		Button horarios = (Button) findViewById(R.id.btnHorarios);
		
		if (horariosLayout.getVisibility()==View.VISIBLE){
			horariosLayout.setVisibility(View.GONE);
			horarios.setBackgroundColor(Color.TRANSPARENT);
			horarios.setCompoundDrawablesWithIntrinsicBounds(getResources().getDrawable(R.drawable.calendar), null, getResources().getDrawable(R.drawable.arrow), null);
			
		}else if (horariosLayout.getVisibility()==View.GONE){
			horariosLayout.setVisibility(View.VISIBLE);
			horarios.setBackgroundColor(0x7789c9ee);
			horarios.setCompoundDrawablesWithIntrinsicBounds(getResources().getDrawable(R.drawable.calendar), null, getResources().getDrawable(R.drawable.arrow_down), null);
		}
	}
	
	public void showInfoNode(View view){
		LinearLayout normativaLayout = (LinearLayout) findViewById(R.id.normativaLayout);
		View separador = (View) findViewById(R.id.separadorNormativa);
		
		Button normativa = (Button) findViewById(R.id.btnNormativa);
		
		if (normativaLayout.getVisibility()==View.VISIBLE){
			normativaLayout.setVisibility(View.GONE);
			separador.setVisibility(View.GONE);
			normativa.setBackgroundColor(Color.TRANSPARENT);
			normativa.setCompoundDrawablesWithIntrinsicBounds(getResources().getDrawable(R.drawable.notes), null, getResources().getDrawable(R.drawable.arrow), null);
			
		}else if (normativaLayout.getVisibility()==View.GONE){
			normativaLayout.setVisibility(View.VISIBLE);
			separador.setVisibility(View.VISIBLE);
			normativa.setBackgroundColor(0x7789c9ee);
			normativa.setCompoundDrawablesWithIntrinsicBounds(getResources().getDrawable(R.drawable.notes), null, getResources().getDrawable(R.drawable.arrow_down), null);
		}
	}
	
	public void showFAQ(View view){
		LinearLayout FAQLayout = (LinearLayout) findViewById(R.id.FAQLayout);
		//View separador = (View) findViewById(R.id.separadorInfoNode);
		
		Button FAQbtn = (Button) findViewById(R.id.btnFAQ);
		
		if (FAQLayout.getVisibility()==View.VISIBLE){
			FAQLayout.setVisibility(View.GONE);
			//separador.setVisibility(View.GONE);
			FAQbtn.setBackgroundColor(Color.TRANSPARENT);
			FAQbtn.setCompoundDrawablesWithIntrinsicBounds(getResources().getDrawable(R.drawable.notes), null, getResources().getDrawable(R.drawable.arrow), null);
			
		}else if (FAQLayout.getVisibility()==View.GONE){
			FAQLayout.setVisibility(View.VISIBLE);
			//separador.setVisibility(View.VISIBLE);
			FAQbtn.setBackgroundColor(0x7789c9ee);
			FAQbtn.setCompoundDrawablesWithIntrinsicBounds(getResources().getDrawable(R.drawable.notes), null, getResources().getDrawable(R.drawable.arrow_down), null);
		}
	}
	
	public void showMapa(View view){
		LinearLayout mapasLayout = (LinearLayout) findViewById(R.id.mapa);
		Button mapa = (Button) findViewById(R.id.btnMapa);
		
		if (mapasLayout.getVisibility()==View.VISIBLE){
			mapasLayout.setVisibility(View.GONE);
			mapa.setBackgroundColor(Color.TRANSPARENT);
			mapa.setCompoundDrawablesWithIntrinsicBounds(getResources().getDrawable(R.drawable.maps), null, getResources().getDrawable(R.drawable.arrow), null);
			
		}else if (mapasLayout.getVisibility()==View.GONE){
			mapasLayout.setVisibility(View.VISIBLE);
			mapa.setBackgroundColor(0x7789c9ee);
			mapa.setCompoundDrawablesWithIntrinsicBounds(getResources().getDrawable(R.drawable.maps), null, getResources().getDrawable(R.drawable.arrow_down), null);
		}
	}
	
	
	public void showNormBurj()
	{
			final CharSequence[] rules=myBurjRules.toArray(new String[myBurjRules.size()]);
			
		    AlertDialog.Builder builder = new AlertDialog.Builder(context);
		    builder.setTitle("InfoNode de BURJ")
		           .setItems(rules, new DialogInterface.OnClickListener() {
		        	   
		            
					public void onClick(DialogInterface dialog, int which) {
		            	   
						DownloadManager dm = (DownloadManager) getSystemService(DOWNLOAD_SERVICE);						
		            	Request request = new Request(
		                           Uri.parse(myBurjCategories.get(which).getLink().replace(" ", "%20")));
		                dm.enqueue(request);    
		           }
		    })
		    .setNegativeButton("Atrs",new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog,int id) {
						dialog.cancel();
					}
				});
		    AlertDialog alertDialog = builder.create();
		    alertDialog.show();
	}
	
	
	
	public void showNormFuenlabrada()
	{
			final CharSequence[] rules=myFuenlaRules.toArray(new String[myFuenlaRules.size()]);
			
		    AlertDialog.Builder builder = new AlertDialog.Builder(context);
		    builder.setTitle("Normativa de Fuenlabrada")
		           .setItems(rules, new DialogInterface.OnClickListener() {
		        	   
		               public void onClick(DialogInterface dialog, int which) {
		            	   View view = getLayoutInflater().inflate(R.layout.norm_f1, null, false);
		            	   selectRulesLayout(which,view);
		            	   
		            	   AlertDialog.Builder builder = new AlertDialog.Builder(context);             	   			
		            	   builder.setView(view);
		            	   builder.setTitle(rules[which])// Add action buttons
        	   	           		  .setNegativeButton("Atrs", new DialogInterface.OnClickListener() {
        	   	           			  public void onClick(DialogInterface dialog,int id) {
        	   	           				  dialog.cancel();
        	   	           			  }
        	   	           		  });		            	   
		            	   AlertDialog d = builder.create();
		            	  		            	   
		            	   // Makes the dialog box fits the 90% of the screen
		            	   WindowManager.LayoutParams lp = new WindowManager.LayoutParams();
		            	   lp.copyFrom(d.getWindow().getAttributes());
		            	   lp.width = WindowManager.LayoutParams.FILL_PARENT;
		            	   lp.height = WindowManager.LayoutParams.FILL_PARENT;
		            	  
		            	   d.show();
		            	   d.getWindow().setAttributes(lp);
		            	   
		            	   
		               
		           }
		    })
		    .setNegativeButton("Atrs",new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog,int id) {
						dialog.cancel();
					}
				});
		    AlertDialog alertDialog = builder.create();
		    alertDialog.show();
	}
	
	public void showFAQ(int index)
	{
		
		
		final CharSequence[] rules=myFAQs.toArray(new String[myFAQs.size()]);				
	    
	   View view = getLayoutInflater().inflate(R.layout.norm_f1, null, false);
	   setFAQContents(index,view);
	   
	   AlertDialog.Builder builder = new AlertDialog.Builder(context);             	   			
	   builder.setView(view);
	   builder.setTitle(rules[index])// Add action buttons
       		  .setNegativeButton("Atrs", new DialogInterface.OnClickListener() {
       			  
       			  public void onClick(DialogInterface dialog,int id) {
       				  dialog.cancel();
       			  }
       		  });		            	   
	   AlertDialog d = builder.create();
	   // Makes the dialog box fits the 90% of the screen
	   WindowManager.LayoutParams lp = new WindowManager.LayoutParams();
	   lp.copyFrom(d.getWindow().getAttributes());
	   lp.width = WindowManager.LayoutParams.FILL_PARENT;
	   lp.height = WindowManager.LayoutParams.FILL_PARENT;
	  
	   d.show();
	   d.getWindow().setAttributes(lp);
	            	  		            	   
	            	   
	            	   
	            	   
	               
	          
		   
	}
	
	
	
	// *************************************************************************************************************
	// *									 Data loading methods                                                  *
	// *************************************************************************************************************

	public void loadDataPestana2()
	{
		int sartsIn=0;
		
		//Cargar horarios
		
		//Parsing and storing the time table
		List<String> horas = loadListString ("http://www.urjc.es/biblioteca/fuenlabrada/Horario/horario.html","td.fondogrande p");
		TextView apertura = (TextView)findViewById(R.id.hHabitual);
		TextView title = (TextView)findViewById(R.id.hTitle);
		TextView prestamo = (TextView)findViewById(R.id.hPrestamo);
		String a =horas.get(0);
		
		sartsIn = a.indexOf("HORARIO HABITUAL");
		title.setText(a.substring(sartsIn, 16));
		apertura.setText(horas.get(0).substring(sartsIn+17, horas.get(0).length()));
		prestamo.setText(horas.get(1));

		List<String> cierres = loadListString("http://www.urjc.es/biblioteca/fuenlabrada/Horario/horario.html","td.fondogrande td.tbodybold");
		TextView enero = (TextView)findViewById(R.id.ene);
		TextView febrero = (TextView)findViewById(R.id.feb);
		TextView marzo = (TextView)findViewById(R.id.mar);
		TextView abril = (TextView)findViewById(R.id.abr);
		TextView mayo = (TextView)findViewById(R.id.may);
		TextView junio = (TextView)findViewById(R.id.jun);
		TextView julio = (TextView)findViewById(R.id.jul);
		TextView agosto = (TextView)findViewById(R.id.ago);
		TextView septiembre = (TextView)findViewById(R.id.sep);
		TextView octubre = (TextView)findViewById(R.id.oct);
		TextView noviembre = (TextView)findViewById(R.id.nov);
		TextView diciembre = (TextView)findViewById(R.id.dic);
		int i=0;
		for (int j=0;j<10;j++)
			if(cierres.size() > i)
			{
				for (int g=0;g<12;g++){
					switch (g) {
					case 0:
						if(cierres.get(i)!="")
						{
							enero.setText(enero.getText().toString() +" "+ cierres.get(i));
						}
						break;
					case 1:
						if(cierres.get(i)!=null)
						{
							febrero.setText(febrero.getText().toString() +" "+ cierres.get(i));
						}
						break;
					case 2:
						if(cierres.get(i)!=null)
						{
							marzo.setText(marzo.getText().toString() +" "+ cierres.get(i));
						}
						break;
					case 3:
						if(cierres.get(i)!=null)
						{
							abril.setText(abril.getText().toString() +" "+ cierres.get(i));
						}
						break;
					case 4:
						if(cierres.get(i)!=null)
						{
							mayo.setText(mayo.getText().toString() +" "+ cierres.get(i));
						}
						break;
					case 5:
						if(cierres.get(i)!=null)
						{
							junio.setText(junio.getText().toString() +" "+ cierres.get(i));
						}
						break;
					case 6:
						if(cierres.get(i)!=null)
						{
							julio.setText(julio.getText().toString() +" "+ cierres.get(i));
						}
						break;
					case 7:
						if(cierres.get(i)!=null)
						{
							agosto.setText(agosto.getText().toString() +" "+ cierres.get(i));
						}
						break;
					case 8:
						if(cierres.get(i)!=null)
						{
							septiembre.setText(septiembre.getText().toString() +" "+ cierres.get(i));
						}
						break;
					case 9:
						if(cierres.get(i)!=null)
						{
							octubre.setText(octubre.getText().toString() +" "+ cierres.get(i));
						}
						break;
					case 10:
						if(cierres.get(i)!=null)
						{
							noviembre.setText(noviembre.getText().toString() +" "+ cierres.get(i));
						}
						break;
					case 11:
						if(cierres.get(i)!=null)
						{
							diciembre.setText(diciembre.getText().toString() +" "+ cierres.get(i));
						}
						break;
					}
					i++;
							
						
				}
			}
		

		
		//Cargar normativa
		// First of all, both categories and its links are taken
		loadFuenlabradaCategories();
		loadBurjCategories();
		

		
		//CARGAR FAQs
		loadFAQ(0, "Informacin especfica de Fuenlabrada", FAQs, "http://www.urjc.es/biblioteca/fuenlabrada/PreguntasFrecuentes/informacionespecifica.html", "td.fondogrande p");
		loadFAQ(1, "Catlogo", FAQs, "http://www.urjc.es/biblioteca/fuenlabrada/PreguntasFrecuentes/catalogo.html", "td.bordetablas p");
		loadFAQ(2, "Adquisiciones", FAQs, "http://www.urjc.es/biblioteca/PreguntasFrecuentes/adquisiciones.html", "td.fondogrande td.menus, td.fondogrande blockquote");
		loadFAQ(3, "Formacin", FAQs, "http://www.urjc.es/biblioteca/PreguntasFrecuentes/formacion.html", "td.fondogrande p");
		loadFAQ(4, "Informacin General", FAQs, "http://www.urjc.es/biblioteca/PreguntasFrecuentes/informaciongeneral.html", "td.fondogrande p");
		loadFAQ(5, "Pasaporte madroo", FAQs, "http://www.urjc.es/biblioteca/PreguntasFrecuentes/pasaportemadrono.html", "td.fondogrande td");
		loadFAQ(6, "Prstmo", FAQs, "http://www.urjc.es/biblioteca/PreguntasFrecuentes/prestamolibros.html", "td.fondogrande p");
		loadFAQ(7, "Prstamo interbibliotecario", FAQs, "http://www.urjc.es/biblioteca/PreguntasFrecuentes/prestamointerbibliotecario.html", "td.fondogrande p");
		loadFAQ(8, "Prstamo intercampus", FAQs, "http://www.urjc.es/biblioteca/PreguntasFrecuentes/prestamointercampus.html", "td.fondogrande p");
	
		
		
		loaded=true;
	}
	
	private void setFAQContents(int index, View view){
		
		LinearLayout rootLayout = (LinearLayout)view.findViewById(R.id.normaLayout);
		LinearLayout LL = new LinearLayout(view.getContext());
		LL.setOrientation(LinearLayout.VERTICAL);
		LL.setLayoutParams(new LayoutParams(
            LayoutParams.FILL_PARENT,
            LayoutParams.FILL_PARENT));
		LinearLayout.LayoutParams lp = new LinearLayout.LayoutParams(LinearLayout.LayoutParams.WRAP_CONTENT, LinearLayout.LayoutParams.WRAP_CONTENT);
		lp.setMargins(10, 10, 10, 10);
		LL.setLayoutParams(lp);
		rootLayout.addView(LL);
		int entrySize=0;
		int entryIndex=0;
		
		switch (index){
		
			case 0:
			case 2:
			case 4:
			case 6:
			case 7:
			case 8:
				//we acces to FAQ0 node to process info
				entrySize = FAQs.get(index).getEntries().size();
				if(index!=2 && index!=7&& index!=8)
					entryIndex=1;
				
				do{
					String actualEntry = FAQs.get(index).getEntries().get(entryIndex);
					if(!isEmptyString(actualEntry))//actualEntry.isEmpty()
						if(actualEntry.substring(0,1).matches("[0-9]"))
						{
							TextView title = new TextView(view.getContext());
							title.setTextAppearance(view.getContext(),  android.R.attr.textAppearanceLarge);
							title.setTextColor(Color.BLUE);
							title.setText(actualEntry);
							title.setLayoutParams(new LayoutParams(
					                LayoutParams.FILL_PARENT,
					                LayoutParams.FILL_PARENT));
							LL.addView(title);
							entryIndex++;
							
						}else{
							
							TextView entry = new TextView(view.getContext());
							entry.setTextAppearance(view.getContext(),  android.R.attr.textAppearanceMedium);
							entry.setText(actualEntry);
							LL.addView(entry);
							entryIndex++;
						}
					else
						entryIndex++;
					
					
				}while(entryIndex<entrySize);
			break;
			
			case 1:
			case 3:
			case 5:
				entrySize = FAQs.get(index).getEntries().size();
				for (int j=0; j< entrySize;j++)
				{
					String entryString=FAQs.get(index).getEntries().get(j);
					int endQ=entryString.indexOf("?");
					
					if (endQ < entryString.indexOf("?", endQ+1))
						endQ=entryString.indexOf("?", endQ+1);
					
					//Set question title
					if (entryString.substring(0, endQ+1).length()>0){
						TextView title = new TextView(view.getContext());
						title.setTextAppearance(view.getContext(),  android.R.attr.textAppearanceLarge);
						title.setTextColor(Color.BLUE);
						title.setText(entryString.substring(0, endQ+1));
						title.setLayoutParams(new LayoutParams(
				                LayoutParams.FILL_PARENT,
				                LayoutParams.FILL_PARENT));
						LL.addView(title);
						//Set answer
						TextView entry = new TextView(view.getContext());
						entry.setTextAppearance(view.getContext(),  android.R.attr.textAppearanceMedium);
						entry.setText(entryString.substring(endQ+1, entryString.length()));
						LL.addView(entry);
					}else{
						TextView entry = new TextView(view.getContext());
						entry.setTextAppearance(view.getContext(),  android.R.attr.textAppearanceMedium);
						entry.setText(entryString);
						LL.addView(entry);
					}
					
				}
			
				break;
				
		
		}
		
	}
	

	
	private void selectRulesLayout(int index, View view) {
		
		
		boolean finished=false;
		
		LinearLayout rootLayout = (LinearLayout)view.findViewById(R.id.normaLayout);
		LinearLayout LL = new LinearLayout(view.getContext());
		LL.setOrientation(LinearLayout.VERTICAL);
		LL.setLayoutParams(new LayoutParams(
            LayoutParams.FILL_PARENT,
            LayoutParams.FILL_PARENT));
		LinearLayout.LayoutParams lp = new LinearLayout.LayoutParams(LinearLayout.LayoutParams.WRAP_CONTENT, LinearLayout.LayoutParams.WRAP_CONTENT);
		lp.setMargins(10, 10, 10, 10);
		LL.setLayoutParams(lp);
		rootLayout.addView(LL);
		
		//We access to normativa nodes to process the info
		int titleSize = myFuenlaCategories.get(index).getTitles().size();
		int entrySize = myFuenlaCategories.get(index).getEntries().size();
		int titleIndex=0;
		int entryIndex=0;
		do{
			if (titleIndex < titleSize ){
				TextView title = new TextView(view.getContext());
				title.setTextAppearance(view.getContext(),  android.R.attr.textAppearanceLarge);
				title.setTextColor(Color.BLUE);
				title.setText(myFuenlaCategories.get(index).getTitles().get(titleIndex));
				title.setLayoutParams(new LayoutParams(
		                LayoutParams.FILL_PARENT,
		                LayoutParams.FILL_PARENT));
				LL.addView(title);
				titleIndex++;
			}
			
			int numberOfOnes=0;
			for (entryIndex=0; entryIndex < entrySize; entryIndex++)
			{
				TextView entry = new TextView(view.getContext());
				entry.setTextAppearance(view.getContext(),  android.R.attr.textAppearanceMedium);
				String entryText=myFuenlaCategories.get(index).getEntries().get(entryIndex);
				if (entryText.charAt(0)=='1')
					numberOfOnes++;
				if (numberOfOnes == titleIndex || titleSize == 0){
					entry.setText(entryText);
					LL.addView(entry);
				}
			}
				
			if( titleIndex == titleSize)
				finished=true;
				
		}while(!finished);
		finished=false;
}
		
		

	

	
	private void loadBurjCategories() {
		
		String url = "http://www.urjc.es/biblioteca/LaBiblioteca/normativas.html";
		String keys="td.fondogrande a";
		Elements elems= null;
		htmlParser parser = new htmlParser();
		parser.execute(url,keys);
		try {
			elems = parser.get();
		} catch (Exception e) {
			e.printStackTrace();
		}
		if(elems !=null)
			for (Element p : elems)
			{
				if(p.text()!="" && p.text()!=" " && p.text()!=null){
					InfoNode norma = new InfoNode();
					myBurjRules.add(p.text());
					norma.setNombre(p.text());
					norma.setLink(p.attr("abs:href"));
					myBurjCategories.add(norma);
				}
			}
		else
			myBurjRules.add("No data provided from the server");
		
	}

	private void loadFuenlabradaCategories() {
		
		String url = "http://www.urjc.es/biblioteca/fuenlabrada/LaBiblioteca/normativas.html";
		String keys="td.fondogrande a";
		Elements elems= null;
		htmlParser parser = new htmlParser();
		parser.execute(url,keys);
		try {
			elems = parser.get();
		} catch (Exception e) {
			e.printStackTrace();
		}
		if( elems !=null)
			for (Element p : elems)
			{
				if(p.text()!="" && p.text()!=" " && p.text()!=null){
					InfoNode norma = new InfoNode();
					myFuenlaRules.add(p.text());
					norma.setNombre(p.text());
					norma.setLink(p.attr("abs:href"));
					loadNode(norma,"td.fondogrande td.tituloblanco",true,false); 	//Loading titles
					loadNode(norma,"td.fondogrande p",false,true); 				// Loading the entries
					myFuenlaCategories.add(norma);
				}
			}	
		else
			myFuenlaRules.add("No data provided from the server");
		
	}
	
	private void loadFAQ (int index, String name, List<InfoNode> FAQs, String url, String keys){
		
		myFAQs.add(index, name);
		List<String> myStrings = new ArrayList<String>();
		myStrings = loadListString(url, keys);
		InfoNode myNode = new InfoNode();
		myNode.setEntries(myStrings);
		FAQs.add(index, myNode);
		
	}
	
	private void loadNode(InfoNode myNode, String keys, boolean titles, boolean entries)
	{
		Elements elems= null;
		htmlParser parser = new htmlParser();
		parser.execute(myNode.getLink(),keys);
		List<String> content =  new ArrayList<String>();
		content.clear();
		try {
			elems = parser.get();
		} catch (Exception e) {
			e.printStackTrace();
		}
		if(elems != null)
			for (Element p : elems)
			{
				if(p.text()!="" && p.text()!=" " && p.text()!=null){				
					content.add(p.text());				
				}
			}
		else
			content.add("No data provided from the server");
			
		if (titles)
			myNode.setTitles(content);
		if (entries)
			myNode.setEntries(content);
		
	}

	
	
	private List<String> loadListString (String url, String keys)
	{
		
		Elements elems= null;
		htmlParser parser = new htmlParser();
		parser.execute(url,keys);
		try {
			elems = parser.get();
		} catch (Exception e) {
			e.printStackTrace();
		}
		List<String> myStrings = new ArrayList<String>();
		if(elems != null)
			for (Element p : elems)
			{
				myStrings.add(p.text());
			}
		else
			myStrings.add("No data provided from the server");
		
		
		return myStrings;
		
	}
	

	
	public boolean IsInternetAvailable(Context context) { 
		
		ConnectivityManager cm = (ConnectivityManager)context.getSystemService(Context.CONNECTIVITY_SERVICE);
		
        return (cm.getActiveNetworkInfo() != null && cm.getActiveNetworkInfo().isAvailable() && cm.getActiveNetworkInfo().isConnected()) ? true : false; 

	}
	
	public boolean isEmptyString(String string)
	{
		boolean isEmpty = false; 
		
				
		if(!"".equals(string) && string != null){
			if("".equals(string.trim()))
					isEmpty=true;
		
		}else
			isEmpty=true;
		
		return isEmpty;
	}
	
	
//	private void lookForTitles(InfoNode myNode)
//	{
//		Elements elems= null;
//		htmlParser parser = new htmlParser();
//		parser.execute(myNode.getLink(),"td.fondogrande td.tituloblanco");
//		List<String> titulos =  new ArrayList<String>();
//		try {
//			elems = parser.get();
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
//		for (Element p : elems)
//		{
//			if(p.text()!="" && p.text()!=" " && p.text()!=null){				
//				titulos.add(p.text());				
//			}
//		}
//		myNode.setTitles(titulos);
//		
//	}
//	private void lookForEntries(InfoNode myNode)
//	{
//		Elements elems= null;
//		htmlParser parser = new htmlParser();
//		parser.execute(myNode.getLink(),"td.fondogrande p");
//		List<String> entries =  new ArrayList<String>();
//		entries.clear();
//		try {
//			elems = parser.get();
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
//		for (Element p : elems)
//		{
//			if(p.text()!="" && p.text()!=" " && p.text()!=null){				
//				entries.add(p.text());				
//			}
//		}
//		myNode.setEntries(entries);
//		
//	}
	
	
//	private List<String> loadDiasCierre() {
//		String url = "http://www.urjc.es/biblioteca/fuenlabrada/Horario/horario.html";
//		String keys="td.fondogrande td.tbodybold";
//		Elements elems= null;
//		htmlParser parser = new htmlParser();
//		parser.execute(url,keys);
//		try {
//			elems = parser.get();
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
//		List<String> myStrings = new ArrayList<String>();
//		for (Element p : elems)
//		{
//			myStrings.add(p.text());
//		}
//		
//		
//		return myStrings;
//	}
//
//	private List<String> loadHorarios() {
//		
//		String url = "http://www.urjc.es/biblioteca/fuenlabrada/Horario/horario.html";
//		String keys="td.fondogrande p";
//		Elements elems= null;
//		htmlParser parser = new htmlParser();
//		parser.execute(url,keys);
//		try {
//			elems = parser.get();
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
//		List<String> myStrings = new ArrayList<String>();
//		for (Element p : elems)
//		{
//			myStrings.add(p.text());
//		}
//		
//		
//		return myStrings;
//		
//	}
	
	
		
}
	
 





