package shockes.burj;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import android.net.ConnectivityManager;
import android.os.Bundle;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.Typeface;
import android.text.Html;
import android.text.method.LinkMovementMethod;
import android.text.util.Linkify;
import android.view.View;
import android.view.ViewGroup.LayoutParams;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.TextView;
import shockes.burj.htmlParser;

public class Pestana3 extends Activity{
	
	private boolean loaded = false;
	private AddresBook myBook = new AddresBook(); 
	
	public class Contact{
		
		private String name = null;
		private String phone = null;
		private String fax = null;
		private String email = null;
		
		public void setName(String myName)		{	name=myName;	}		
		public void setTel(String myPhone)		{	phone=myPhone;	}
		public void setFax(String myFax)		{	fax=myFax;		}		
		public void setEmail (String myEmail)	{	email=myEmail;	}
		
		public String getName()	{	return name;	}
		public String getPhone(){	return phone;	}
		public String getFax()	{	return fax;		}
		public String getEmail(){	return email;	}
	}
	
	public class ContactType{
		
		private List<Contact> myContactType = new ArrayList<Contact>();
		private int contactNum = 0;
		private String name = null;
		
		public void addContact( Contact newContact)
		{
			myContactType.add(newContact);
			contactNum++;
		}
		
		public void setName( String myName)	{ 	name=myName;	}
		
		public int getSize()				{	return contactNum;	}
		
		public Contact getContact(int i)
		{
			Contact actual = null;
			
			if (myContactType.get(i) != null)
				actual = myContactType.get(i);
			
			return actual;
		}
	}
	
	public class AddresBook{
		
		private List<ContactType> myTypes = new ArrayList<ContactType>();
		private int typeNum = 0;
		
		public void addType(ContactType newType )
		{
			myTypes.add(newType);
			typeNum++;
		}
		
		public int getSize()	{	return typeNum;		}
		
		public ContactType getType(int i)
		{
			ContactType actual = null;
			
			if (myTypes.get(i) != null)
				actual = myTypes.get(i);
			
			return actual;
		}
	}
	
	@Override
	public void onCreate(Bundle savedInstanceState){
		super.onCreate(savedInstanceState);
			
		setContentView(R.layout.pestana3);
		
		//=================== Botones ==============================
		Button email = (Button) findViewById(R.id.btnEmail);
		email.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				showEmail(v);
				
			}
		});
		
		Button postalMail = (Button)findViewById(R.id.btnPostalMail);
		postalMail.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				showPostalMail(v);
				
			}
		});
		
		Button formulario = (Button)findViewById(R.id.btnForm);
		formulario.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				showFormulario(v);
				
			}
		});
		
 		Button faxPhone = (Button)findViewById(R.id.btnFaxPhone);
		faxPhone.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				showFaxPhone(v);
				
			}
		});
		
		
		// ====================== MAIL ===========================
		Button btnSend = (Button) findViewById(R.id.button4);
		btnSend.setOnClickListener(new View.OnClickListener() {
		   
		    public void onClick(View v) {
		    	sendEmail(v);
		    }
		});
		
		// ====================== FORM ===========================
		RadioButton radioEmail = (RadioButton)findViewById(R.id.radioEmailForm);
		radioEmail.setOnClickListener(new View.OnClickListener() {
		   
		    public void onClick(View v) {
		    	showEmailFormEditText(v);
		    }
		});
		
		RadioButton radioPhone = (RadioButton)findViewById(R.id.radioPhoneForm);
		radioPhone.setOnClickListener(new View.OnClickListener() {
		   
		    public void onClick(View v) {
		    	showPhoneFormEditText(v);
		    }
		});
		
		Button sendForm = (Button)findViewById(R.id.btnSendForm);
		sendForm.setOnClickListener(new View.OnClickListener() {
		   
		    public void onClick(View v) {
		    	sendForm(v);
		    }
		});
		
		
		if(!loaded)
			loadDataPestana3();
			
		
	}
	
	public void showFormulario (View view)
	{
		
		LinearLayout formLayout = (LinearLayout) findViewById(R.id.formLayout);
		Button form = (Button) findViewById(R.id.btnForm);
		
		if (formLayout.getVisibility()==View.VISIBLE){
			formLayout.setVisibility(View.GONE);
			form.setBackgroundColor(Color.TRANSPARENT);
			form.setCompoundDrawablesWithIntrinsicBounds(getResources().getDrawable(R.drawable.form), null, getResources().getDrawable(R.drawable.arrow), null);
			
		}else if (formLayout.getVisibility()==View.GONE){
			formLayout.setVisibility(View.VISIBLE);
			form.setBackgroundColor(0x7789c9ee);
			form.setCompoundDrawablesWithIntrinsicBounds(getResources().getDrawable(R.drawable.form), null, getResources().getDrawable(R.drawable.arrow_down), null);
		}		
		
	}
	
	public void showEmailFormEditText(View view)
	{
		EditText Email = (EditText)findViewById(R.id.formEmail);
		Email.setVisibility(View.VISIBLE);
		
		EditText Phone = (EditText)findViewById(R.id.formPhone);
		Phone.setVisibility(View.GONE);
		
	}
	
	public void showPhoneFormEditText(View view)
	{
		EditText Email = (EditText)findViewById(R.id.formEmail);
		Email.setVisibility(View.GONE);
		
		EditText Phone = (EditText)findViewById(R.id.formPhone);
		Phone.setVisibility(View.VISIBLE);
		
	}
	
	public void showEmail (View view)	{
		LinearLayout emailLayout = (LinearLayout) findViewById(R.id.email);
		Button email = (Button) findViewById(R.id.btnEmail);
		
		if (emailLayout.getVisibility()==View.VISIBLE){
			emailLayout.setVisibility(View.GONE);
			email.setBackgroundColor(Color.TRANSPARENT);
			email.setCompoundDrawablesWithIntrinsicBounds(getResources().getDrawable(R.drawable.email), null, getResources().getDrawable(R.drawable.arrow), null);
			
		}else if (emailLayout.getVisibility()==View.GONE){
			emailLayout.setVisibility(View.VISIBLE);
			email.setBackgroundColor(0x7789c9ee);
			email.setCompoundDrawablesWithIntrinsicBounds(getResources().getDrawable(R.drawable.email), null, getResources().getDrawable(R.drawable.arrow_down), null);
		}
		
	}
	
	public void showPostalMail (View view)	{
		LinearLayout mailLayout = (LinearLayout) findViewById(R.id.postalMail);
		Button mail = (Button) findViewById(R.id.btnPostalMail);
		
		if (mailLayout.getVisibility()==View.VISIBLE){
			mailLayout.setVisibility(View.GONE);
			mail.setBackgroundColor(Color.TRANSPARENT);
			mail.setCompoundDrawablesWithIntrinsicBounds(getResources().getDrawable(R.drawable.mail), null, getResources().getDrawable(R.drawable.arrow), null);
			
		}else if (mailLayout.getVisibility()==View.GONE){
			mailLayout.setVisibility(View.VISIBLE);
			mail.setBackgroundColor(0x7789c9ee);
			mail.setCompoundDrawablesWithIntrinsicBounds(getResources().getDrawable(R.drawable.mail), null, getResources().getDrawable(R.drawable.arrow_down), null);
		}
		
	}
	
	public void showFaxPhone (View view)	{
		
		LinearLayout faxPhoneL = (LinearLayout) findViewById(R.id.addresBookLayout);
		Button faxPhoneButton = (Button) findViewById(R.id.btnFaxPhone);
		
		if (faxPhoneL.getVisibility()==View.VISIBLE){
			faxPhoneL.setVisibility(View.GONE);
			faxPhoneButton.setBackgroundColor(Color.TRANSPARENT);
			faxPhoneButton.setCompoundDrawablesWithIntrinsicBounds(getResources().getDrawable(R.drawable.phone), null, getResources().getDrawable(R.drawable.arrow), null);
			
		}else if (faxPhoneL.getVisibility()==View.GONE){
			faxPhoneL.setVisibility(View.VISIBLE);
			faxPhoneButton.setBackgroundColor(0x7789c9ee);
			faxPhoneButton.setCompoundDrawablesWithIntrinsicBounds(getResources().getDrawable(R.drawable.phone), null, getResources().getDrawable(R.drawable.arrow_down), null);
		}
		
	}
	
	public void loadDataPestana3()
	{
		

		// Carga correo postal
		loadPostalMailData();

		// Carga de fax y telelfonos
		loadContactsDirectory(findViewById(R.id.addresBookLayout));

		
		loaded=true;
	}
	
	private void loadContactsDirectory(View view) {
		
		LinearLayout addBook = (LinearLayout)findViewById(R.id.addresBookLayout);
		String url = "http://www.urjc.es/biblioteca/fuenlabrada/LaBiblioteca/directorio.html";
		String keys="table.tbody table td";
		Elements elems= null;
		htmlParser parser = new htmlParser();
		parser.execute(url,keys);
		try {
			elems = parser.get();
		} catch (Exception e) {
			e.printStackTrace();
		}	
		
		String elementClass;
		int cont=0;
		
		for (Element p : elems)
		{
			elementClass = p.className();
			if(p.text()!="" && p.text()!=" " && p.text()!=null)
			{
				switch (typeOfClass(elementClass))
				{
				
				case 1: // tituloblanco
					TextView tvTitle = new TextView(view.getContext());
						tvTitle.setText(p.text());
						tvTitle.setTextColor(Color.BLUE);
						tvTitle.setPadding(10, 10, 0, 0);					
						tvTitle.setTextAppearance(view.getContext(),  android.R.attr.textAppearanceLarge);
						tvTitle.setTypeface(null, Typeface.BOLD);
						tvTitle.setLayoutParams(new LayoutParams(
				                LayoutParams.FILL_PARENT,
				                LayoutParams.FILL_PARENT));
						addBook.addView(tvTitle);
					
					break;
					
				case 2: // bordetablasinterior
					
					TextView tv = new TextView(view.getContext());
					switch (cont){
						case 0:
							tv.setTextAppearance(view.getContext(),  android.R.attr.textAppearanceMedium);
							tv.setPadding(20, 10, 0, 0);
							tv.setTypeface(null, Typeface.BOLD);
							tv.setText(p.text());				
							addBook.addView(tv);
							break;
						case 1:
							tv.setTextAppearance(view.getContext(),  android.R.attr.textAppearanceMedium);
							tv.setPadding(20, 0, 0, 0);
							tv.setAutoLinkMask(Linkify.PHONE_NUMBERS);
							tv.setText("Telf: " + p.text());				
							addBook.addView(tv);
							break;
							
						case 2:
							tv.setTextAppearance(view.getContext(),  android.R.attr.textAppearanceMedium);
							tv.setPadding(20, 0, 0, 0);
							tv.setText("Fax: " + p.text());				
							addBook.addView(tv);
							break;
							
						case 3:
							tv.setTextAppearance(view.getContext(),  android.R.attr.textAppearanceMedium);
							tv.setPadding(20, 0, 0, 0);
							tv.setText(Html.fromHtml("<a href=\"mailto:"+p.text()+"\">"+p.text()+"</a>"));
							tv.setMovementMethod(LinkMovementMethod.getInstance());
							addBook.addView(tv);
							break;
					}
					
					if (cont<3)
						cont++;
					else
						cont=0;
					break;
				default:
					break;
				
				
				}
			}
		}		
	}

	private void loadPostalMailData(){
		
		TextView direccion = (TextView)findViewById(R.id.target);
		String url = "http://www.urjc.es/biblioteca/fuenlabrada/";
		String keys="td.nombreydireccion p";
		Elements elems= null;
		htmlParser parser = new htmlParser();
		parser.execute(url,keys);
		try {
			elems = parser.get();
		} catch (Exception e) {
			e.printStackTrace();
		}			
		
		for (Element p : elems)
		{
			if(p.text()!="" && p.text()!=" " && p.text()!=null){
				
				direccion.setText( p.text());
	
			}
		}		
	}
	
	public void sendEmail (View view){
		
		 //obtenemos los datos para el envo del correo 
        TextView etEmail = (TextView) findViewById(R.id.toET);
        EditText etSubject = (EditText) findViewById(R.id.asuntoET);
        EditText etBody = (EditText) findViewById(R.id.bodyET);
        //CheckBox chkAttachment = (CheckBox) findViewById(R.id.chkAttachment);
 
        //es necesario un intent que levante la actividad deseada 
        Intent itSend = new Intent(android.content.Intent.ACTION_SEND);
 
        itSend.setType("plain/text");
 
        //colocamos los datos para el envo
        itSend.putExtra(android.content.Intent.EXTRA_EMAIL, new String[]{ etEmail.getText().toString()});
        itSend.putExtra(android.content.Intent.EXTRA_SUBJECT, etSubject.getText().toString());
        itSend.putExtra(android.content.Intent.EXTRA_TEXT, etBody.getText());
        
        startActivity(itSend);
		
		
		
	}
	
	public int typeOfClass(String elemClass)
	{
		int classType=0;
		
		if (elemClass.contentEquals("tituloblanco"))
			classType=1;
		else if (elemClass.contentEquals("bordetablasinterior"))
			classType=2;
		
		return classType;
		
	}
	

	public void sendForm(View view)
	{
		EditText nombreF = (EditText)findViewById(R.id.formNombreEdit);
		EditText consultaF = (EditText)findViewById(R.id.formConsultaEdit);
		EditText emailF = (EditText)findViewById(R.id.formEmail);
		EditText phoneF = (EditText)findViewById(R.id.formPhone);
		RadioButton radioEmail = (RadioButton)findViewById(R.id.radioEmailForm);
		RadioButton radioPhone = (RadioButton)findViewById(R.id.radioPhoneForm);
		
		if(isEmptyString(nombreF.getText().toString()) 		||	//isEmptyString(String string) nombreF.getText().toString().isEmpty()
		   isEmptyString(consultaF.getText().toString())  	|| 	//isEmptyString(String string) consultaF.getText().toString().isEmpty()
		   (isEmptyString(emailF.getText().toString()) 		 &&	//isEmptyString(String string) emailF.getText().toString().isEmpty()
			isEmptyString(phoneF.getText().toString())))		//isEmptyString(String string) phoneF.getText().toString().isEmpty()
			{
			
			AlertDialog.Builder alert = new AlertDialog.Builder(this);
			alert.setTitle("Atencin");
			alert.setMessage("Uno de los campos no contiene datos. Rellene todos los campos para completar la consulta.");
			final TextView input = new TextView (this);
			alert.setView(input);
			
			alert.setPositiveButton("Ok", new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int whichButton) {
				     input.setText("hi");
				    // Do something with value!
				  }
				});

				  alert.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
				  public void onClick(DialogInterface dialog, int whichButton) {
				      // Canceled.
				  }
				});
				alert.show();
			
			}
		else
		{
		
			HttpClient httpclient = new DefaultHttpClient();
		    HttpPost httppost = new HttpPost("http://www.urjc.es/biblioteca/Formularios/PHPs");//formulario_consulta_bibliotecario.php");
	
		    try {
		        // Add your data
		        List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>(4);
		        nameValuePairs.add(new BasicNameValuePair("Nombre", nombreF.getText().toString()));
		        nameValuePairs.add(new BasicNameValuePair("Consulta", consultaF.getText().toString()));
		        if (radioEmail.isChecked())
		        	nameValuePairs.add(new BasicNameValuePair("Email", emailF.getText().toString()));
		        else
		        	nameValuePairs.add(new BasicNameValuePair("Tel&eacute;fono", phoneF.getText().toString()));
		        httppost.setEntity(new UrlEncodedFormEntity(nameValuePairs));
	
		        // Execute HTTP Post Request
		        HttpResponse response = httpclient.execute(httppost);
	
		    } catch (ClientProtocolException e) {
		        // TODO Auto-generated catch block
		    } catch (IOException e) {
		        // TODO Auto-generated catch block
		    }
			
		}
		
		
	}
	
	public boolean IsInternetAvailable(Context context) { 
		
		ConnectivityManager cm = (ConnectivityManager)context.getSystemService(Context.CONNECTIVITY_SERVICE);
		
        return (cm.getActiveNetworkInfo() != null && cm.getActiveNetworkInfo().isAvailable() && cm.getActiveNetworkInfo().isConnected()) ? true : false; 

	}
	
	public boolean isEmptyString(String string)
	{
		boolean isEmpty = false; 
		
				
		if(!"".equals(string) && string != null){
			if("".equals(string.trim()))
					isEmpty=true;
		
		}else
			isEmpty=true;
		
		return isEmpty;
	}

}
