package shockes.burj;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.ArrayList;

import org.apache.http.util.EncodingUtils;

import shockes.burj.Pestana1.IFace;
import shockes.burj.Pestana1.myAdapter;
import shockes.burj.myParser.Node;

import android.net.ConnectivityManager;
import android.os.Bundle;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.ListActivity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.webkit.WebChromeClient;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;


@SuppressLint("SetJavaScriptEnabled")
public class Pestana4 extends ListActivity{
	
	public static String htmlGlobal=""; //Stores the html code that has been previously downloaded
	public static int loadedControl=1;
	private static ArrayList<Node> myLoans= new ArrayList<Node>();
	private myAdapter entryAdap = null;
	String fileName="credentials.txt";
	FileInputStream myFileRead;
	FileOutputStream myFileWrite;
	
	// Adapter to manage the entry list
	public static class myAdapter extends BaseAdapter{
		
		private Context myContext=null;
    	
    	public myAdapter(Context context)
    	{
    		myContext=context;
    	}

		public int getCount() {
			
			return myLoans.size();
		}

		public Object getItem(int position) {
			
			return myLoans.get(position);
		}

		public long getItemId(int position) {
			
			return 0;
		}

		public View getView(int position, View convertView, ViewGroup parent) {
			
			View view = null;
			if (convertView == null)
			{
				LayoutInflater inflater = (LayoutInflater) myContext
						.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				view = inflater.inflate(R.layout.entradaprestamos, null);
			}else
			{
				view = convertView;
			}
			
			TextView title = (TextView) view.findViewById(R.id.entradaPrestTitle);
			title.setText(myLoans.get(position).title);
			
			TextView author = (TextView) view.findViewById(R.id.entradaPrestAutor);
			author.setText(myLoans.get(position).author);
			
			TextView vencimiento = (TextView) view.findViewById(R.id.entradaPrestVencimiento);
			vencimiento.setText(myLoans.get(position).deadline);
			
			TextView sancion = (TextView) view.findViewById(R.id.entradaPrestSancion);
			sancion.setText(myLoans.get(position).sanction);
					
			
			return view;
		}
		
	}
	
	public class IFace {
    	
    	public void print(String data) {
            data ="<html>"+data+"</html>";
            Pestana4.htmlGlobal=data;
           
        }
    	
    }
	
	@Override
	public void onCreate(Bundle savedInstanceState){
		super.onCreate(savedInstanceState);
		
		setContentView(R.layout.pestana4);
		
		entryAdap = new myAdapter(this);
		setListAdapter(entryAdap);
		
		
		// Button Creation
		Button submmit = (Button)findViewById(R.id.cuentaSend);
		
		
		submmit.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {  // Launching the search
				
				if (IsInternetAvailable(getApplicationContext())){ //Checking network connection
				
					EditText cuentaID = (EditText) findViewById(R.id.cuentaID);
					EditText cuentaPIN_ID = (EditText) findViewById(R.id.cuentaPINID);
					
					if (cuentaID.getText().length()==0) // There's no ID info
						Toast.makeText(getApplicationContext(), "Debes introducir el identificador para acceder a tu cuenta", Toast.LENGTH_SHORT).show();
					else if(cuentaPIN_ID.getText().length()==0) // There's no PIN entered
						Toast.makeText(getApplicationContext(), "Debes introducir el PIN para acceder a tu cuenta", Toast.LENGTH_SHORT).show();
					else
					{ 
						// Everything is OK						
						hideKeyboard(v);						   			
		    			htmlGlobal="";
		    			logON(v);
		    			
		    			saveCrendentials(cuentaID.getText().toString()+"#"+cuentaPIN_ID.getText().toString()+"#");
											
					}
					
				}else  // No network connection
		    		Toast.makeText(getApplicationContext(), "No existe una conexin de datos disponible. No se puede realizar la bsqueda.", Toast.LENGTH_LONG).show();
				
			}

			

		});
		CheckBox recordar = (CheckBox)findViewById(R.id.recordarCuenta);
		String[] files = getApplicationContext().fileList();
		// File checking
		try {
			myFileRead = openFileInput(fileName);
			byte[] buffer = new byte[1024];
			myFileRead.read(buffer);
			myFileRead.close();
			StringBuffer pollas = new StringBuffer("");
			pollas.append(new String(buffer));
			initializeCredentials(pollas.toString());
			
			recordar.setChecked(true);
			  
		} catch (Exception e) {
		  e.printStackTrace();
		  recordar.setChecked(false);
		}
	}
	
	private void initializeCredentials(String buffer) 
	{
		
		EditText cuentaID = (EditText)findViewById(R.id.cuentaID);
		EditText passPIN = (EditText)findViewById(R.id.cuentaPINID);
		int index=buffer.indexOf("#");
		cuentaID.setText(buffer.substring(0, index));
		String aux= buffer.substring(index+1, buffer.length());
		index= aux.indexOf("#");
		passPIN.setText(aux.substring(0, index));
		
	}
	
	
	private void saveCrendentials(String string) 
	{

		CheckBox recordar = (CheckBox)findViewById(R.id.recordarCuenta);

		if(recordar.isChecked())
		{
			try {
				
				myFileWrite = openFileOutput(fileName, Context.MODE_PRIVATE);
				myFileWrite.write(string.getBytes());
				myFileWrite.close();
				
			} catch (Exception e) 
			{
				e.printStackTrace();
			}
		}else
		{
			try
			{
				getApplicationContext().deleteFile(fileName);
			}
			catch (Exception e) 
			{
				e.printStackTrace();
			}
		}
		
	}


	private void logON(View v) {
		
		final WebView web = (WebView)findViewById(R.id.cuentaBrowser);
		final ProgressDialog pDialog = ProgressDialog.show(Pestana4.this, "", "Accediendo a la biblioteca");
		pDialog.setProgress(0);
		web.getSettings().setJavaScriptEnabled(true);
		web.setWebChromeClient(new WebChromeClient()
    	{
    		@Override
            public void onProgressChanged(WebView view, int progress) 
            {    		
    			pDialog.setProgress(progress);           
            }
    	});
		web.setWebViewClient(new WebViewClient()
		{
			
    		
			@Override
        	public void onPageFinished(WebView view, String url) 
    		{
    			
                super.onPageFinished(view, url);
                
                if(Pestana4.loadedControl==1){
                	
                	Pestana4.loadedControl=2;
                	EditText cuentaID = (EditText) findViewById(R.id.cuentaID);
					EditText cuentaPIN_ID = (EditText) findViewById(R.id.cuentaPINID);
        			byte[] post = EncodingUtils.getBytes("user_id="+cuentaID.getText().toString()+"&password="+cuentaPIN_ID.getText().toString(), "BASE64");
            		web.postUrl("http://centauro.urjc.es/uhtbin/cgisirsi/?ps=sB0jQP4H6B/CENTRAL/0/57/49", post);            		
            		
                }else if (Pestana4.loadedControl==2){ // Once library page answers, the number session is processed and the post query done
            	
                	Pestana4.loadedControl=3;
            		String myurl= web.getUrl();
            																					  
            		if (myurl.equalsIgnoreCase("http://centauro.urjc.es/uhtbin/cgisirsi/0/0/0/57/49") || myurl.equalsIgnoreCase("http://centauro.urjc.es/uhtbin/cgisirsi/?ps=sB0jQP4H6B/CENTRAL/0/57/49"))
            		{
            			Pestana4.loadedControl=1;
            			pDialog.dismiss();
            			Toast.makeText(getApplicationContext(), "Los datos introducidos nos son correctos. Por favor, intntelo de nuevo", Toast.LENGTH_SHORT).show();
            			pDialog.dismiss();
            			
            			
            		}
            		else  if(myurl.length()>63)           			
            		{
            			int firstIndex=myurl.indexOf("/FUENLABRAD/");
	        			String aux=myurl.substring(firstIndex+12,myurl.length());	        			
	        			int index=aux.lastIndexOf("/60/");
	        			String sessionNum = aux.substring(0,index);
	        			pDialog.setMessage("Recibiendo datos");
	        			web.loadUrl("http://centauro.urjc.es/uhtbin/cgisirsi/?ps=6pfWLG4Jks/FUENLABRAD/"+sessionNum+"/30");  // Library page is loaded
            			
            			
            		}else 
            		{
            			Pestana4.loadedControl=1;
            			pDialog.dismiss();
            			Toast.makeText(getApplicationContext(), "El WebCat no est disponible en este momento. Por favor, intntelo ms tarde", Toast.LENGTH_SHORT).show();
            			pDialog.dismiss();
            			
            		}
            		
                }else if (Pestana4.loadedControl==3){  //Once we have the answer to our post we are going to get the html code and process it. 

                	Pestana4.loadedControl=1;
            		String ht = "javascript:window.droid.print(document.getElementsByTagName('html')[0].innerHTML);";
            		web.loadUrl(ht);
            		while(isEmptyString(Pestana4.htmlGlobal)); // isEmptyString(String string) Pestana4.htmlGlobal.isEmpty()
            		pDialog.setMessage("Mostrando contenido...");
            		parseLoans(view);
            		pDialog.dismiss();
            		LinearLayout credenciales = (LinearLayout)findViewById(R.id.passLayout);
            		credenciales.setVisibility((View.GONE));
            		LinearLayout listaPrestamos = (LinearLayout)findViewById(R.id.prestamosListLayout);
            		listaPrestamos.setVisibility((View.VISIBLE));
                }
            }
    		
    		
    	});
		web.addJavascriptInterface(new IFace(), "droid");
		web.loadUrl("http://centauro.urjc.es/uhtbin/webcat");  // Library page is loaded
	}
	
	private void parseLoans(View view)
	{
		myParser htmlParser = new myParser(htmlGlobal,this);
		if(htmlParser.parseHtmlLoans())
    	{
    		myLoans = htmlParser.getParsed();    		
    		entryAdap.notifyDataSetChanged();
    	}
    	else
    		Toast.makeText(getApplicationContext(), "No existen resultados para esa entrada", Toast.LENGTH_SHORT).show();
	}
	
	private void hideKeyboard(View v) {
		
		InputMethodManager tecladoVirtual = (InputMethodManager) getSystemService(Context .INPUT_METHOD_SERVICE );
		tecladoVirtual.hideSoftInputFromWindow(v.getWindowToken(), 0);
		
	}

	public boolean IsInternetAvailable(Context context) { 
		
		ConnectivityManager cm = (ConnectivityManager)context.getSystemService(Context.CONNECTIVITY_SERVICE);
		
        return (cm.getActiveNetworkInfo() != null && cm.getActiveNetworkInfo().isAvailable() && cm.getActiveNetworkInfo().isConnected()) ? true : false; 

	}
	
	
	public boolean isEmptyString(String string)
	{
		boolean isEmpty = false; 
		
				
		if(!"".equals(string) && string != null){
			if("".equals(string.trim()))
					isEmpty=true;
		
		}else
			isEmpty=true;
		
		return isEmpty;
	}
}
