package shockes.burj;

import java.util.ArrayList;
import android.content.Context;

public class myParser {
	
	private String myText=null;
	private ArrayList<Node> myNodes=null;
	
	public class Node
	{
		public String title;
		public String author;
		public String ISBAN;
		public String availability;
		public String deadline;
		public String sanction;
	}
	
	
	
	public myParser(String text, Context context){
		
		myText=text;
		myNodes = new ArrayList<Node>();
		
	}
	
	public ArrayList<Node> getParsed()
	{
		return myNodes;		
	}
	
	public boolean parseHtmlLoans()
	{
		boolean parsed=false;
		String toParse=myText;
		
		
		// A sequential and systematic parsing is going to be implemented
		boolean anotherNode = true;
		int index=1;
		int startSearchIn=0;
		int endSearch=0;
		String auxParseString=toParse;
		String auxParseString2=null;
		
		if(myNodes!=null)
			myNodes.clear();
		do
		{
			if(auxParseString.contains("<!-- Title -->"))
			{
				parsed=true;
				Node n = new Node();
				
				//title
				startSearchIn = auxParseString.indexOf("<!-- Title -->");
				auxParseString=auxParseString.substring(startSearchIn,auxParseString.length());
				endSearch=auxParseString.indexOf("</td>");
				n.title=auxParseString.substring(27, endSearch-9);
	
				
				//author
				auxParseString2=auxParseString.substring(endSearch,auxParseString.length());
				startSearchIn = auxParseString2.indexOf("<!-- Author -->");
				auxParseString=auxParseString2.substring(startSearchIn,auxParseString2.length());
				endSearch=auxParseString.indexOf("</td>");
				n.author=auxParseString.substring(28, endSearch);
				
				//deadline
				auxParseString2=auxParseString.substring(endSearch,auxParseString.length());
				startSearchIn = auxParseString2.indexOf("<strong>");
				auxParseString=auxParseString2.substring(startSearchIn,auxParseString2.length());
				endSearch=auxParseString.indexOf("</strong>");
				n.deadline=auxParseString.substring(8, endSearch);
				
				//sanction
				auxParseString2=auxParseString.substring(endSearch,auxParseString.length());
				if(auxParseString2.contains("<!-- Est Fines -->"))
				{
					startSearchIn = auxParseString2.indexOf("<em>");
					if(startSearchIn!=-1)
					{
						auxParseString=auxParseString2.substring(startSearchIn,auxParseString2.length());
						endSearch=auxParseString.indexOf("</em>");
						n.sanction=auxParseString.substring(4, endSearch);
					}
					else{
						n.sanction="";
					}
				}
				
				myNodes.add(n);
				
			}else
				anotherNode=false;
		
		}while(anotherNode);
		
		
		
		return parsed;
		
	}
	
	public boolean parseHtml(){
		
		boolean parsed=false;
		String toParse=myText;
		
		if (contentExist())
			parsed=true;
		
		// A sequential and systematic parsing is going to be implemented
		boolean anotherNode = true;
		int index=1;
		int startSearchIn=0;
		String auxParseString=null;
		
		if(myNodes!=null)
			myNodes.clear();
		
		if (myText.contains(singleNode()))
		{ // In case of single result for the search
			
			startSearchIn = toParse.indexOf(singleNode());
			auxParseString=toParse.substring(startSearchIn,toParse.length());
			
			Node n = new Node();
			
			n.ISBAN = getSingleIsban(auxParseString);
			n.title = getSingleTitle(auxParseString);
			n.author = getSingleAuthor(auxParseString);
			n.availability = getSingleAvailability(auxParseString);
			
			myNodes.add(n);
			
		}else
		{ // Several results for the search
			do{
				if(myText.contains(updateNodeID(index))) // In case of several results, is there another
				{
					// The useless information is removed 
					startSearchIn = toParse.indexOf(updateNodeID(index));
					auxParseString=toParse.substring(startSearchIn,toParse.length());
					
					Node n = new Node();
					
					
					n.ISBAN = getNextIsban(auxParseString); // Parse ISBAN
					n.title = getNextTitle(auxParseString); // Parse title
					n.author = getNextAuthor(auxParseString); // Parse author
					n.availability = getNextAvailability(auxParseString); // Parse availability				
					myNodes.add(n);
					
					index++;	
				}
				else 
					anotherNode=false;				
				
			}while(anotherNode);
		}
		
		return parsed;
	}
	
	private String getSingleAvailability(String auxParseString) {
		// <!-- show if catalog or call-num item view -->
		int indexStart=0;
		int indexEnd=0;
		String availability=null;
		
		indexStart=auxParseString.indexOf("<!-- show if catalog or call-num item view -->");
		String auxParsing=auxParseString.substring(indexStart);
		indexEnd=auxParsing.indexOf("<br>");
		availability=auxParsing.substring(50, indexEnd);	
		
		
		return availability;
	}

	private String getSingleAuthor(String auxParseString) {
		
		int indexStart=0;
		int indexEnd=0;
		String author=null;
		
		indexStart=auxParseString.indexOf("<!-- Print the author, if one exists -->");
		String auxParsing=auxParseString.substring(indexStart);
		indexStart=auxParsing.indexOf("&nbsp;&nbsp;&nbsp;&nbsp;");
		indexEnd=auxParsing.indexOf("<br>");
		author=auxParsing.substring(indexStart+24, indexEnd);
		
		
		return author;
	}

	private String getSingleTitle(String auxParseString) {
		
		int indexStart=0;
		int indexEnd=0;
		String title=null;
		
		indexStart=auxParseString.indexOf("<strong>");
		indexEnd=auxParseString.indexOf("</strong>");
		title=auxParseString.substring(indexStart+8, indexEnd);
		
		return title;
	}

	private String getSingleIsban(String auxParseString) {
		
		int indexStart=0;
		int indexEnd=0;
		String ISBAN=null;
		
		indexStart = auxParseString.indexOf("<!-- Print ISBN number, if exists -->");
		String auxParsing = auxParseString.substring(indexStart);
		indexStart=auxParsing.indexOf("<td class=\"viewmarctags\">");
		indexEnd=auxParsing.indexOf("</td>");
		ISBAN=auxParsing.substring(indexStart+25,indexEnd);		
		
		return ISBAN;
	}

	private String getNextAvailability(String toParse) {
		int indexStart=0;
		int indexEnd=0;
		String availability=null;
		
		indexStart=toParse.indexOf("<p>");
		String auxParsing=toParse.substring(indexStart,toParse.length());
		indexEnd=auxParsing.indexOf("<br>");
		availability=auxParsing.substring(24, indexEnd);
		
		return availability;
	}

	private String getNextAuthor(String toParse) {
		int indexStart=0;
		int indexEnd=0;
		String author=null;
		
		indexStart=toParse.indexOf("&nbsp;&nbsp;");
		String auxParsing=toParse.substring(indexStart,toParse.length());
		indexEnd=auxParsing.indexOf("\n");
		author=auxParsing.substring(12, indexEnd);
		
		return author;
	}

	private String getNextTitle(String toParse) {
		
		int indexStart=0;
		int indexEnd=0;
		String title=null;
		
		indexStart=toParse.indexOf("<!-- title -->");
		String auxParsing=toParse.substring(indexStart, toParse.length());
		indexStart=auxParsing.indexOf("<strong>");
		indexEnd=auxParsing.indexOf("</strong>");
		title=auxParsing.substring(indexStart+8, indexEnd);
		
		return title;
	}

	private String getNextIsban(String toParse) {
		
		int indexStart=0;
		int indexEnd=0;
		String ISBAN=null;		
		
		indexStart=toParse.indexOf("<strong>");
		indexEnd=toParse.indexOf("</strong>");
		ISBAN=toParse.substring(indexStart+8, indexEnd);
		
		return ISBAN;
	}

	private String  updateNodeID(int id)
	{
		
		String nodeId="<input type=\"submit\" value=\"Detalles\" name=\"VIEW^"+Integer.toString(id)+"\" id=\"VIEW"+Integer.toString(id)+"\" class=\"itemdetails";
		
		return nodeId;
	}
	
	private String singleNode(){
		return "<!-- Print the title, if one exists -->";
		
	}

	private boolean contentExist() {
		boolean exist=true;
		
		if(myText.contains("no encontr registros en")) // The original sentense :no encontr registros en ninguna biblioteca. But there is a problem with the matching
			exist=false;
	
		return exist;
	}
	
	 public void parseHTMLSimulated()
	    {
	    	if(myNodes != null)
	    		myNodes.clear();
	    	
	    	Node n = new Node();
	    	n.ISBAN = "LAM 004.438HTML5 FULL htm";
	    	n.title = "The test node Vol.1";
	    	n.author = "B. J. Tester1";
			n.availability = "1 Copia disponible en la Test1";
			
			myNodes.add(n);
			
			Node m = new Node();
	    	m.ISBAN = "LAM 070.41 VIL men";
	    	m.title = "The test node Vol.2";
	    	m.author = "B. J. Tester2";
			m.availability = "1 Copia disponible en la Test2";
			
			myNodes.add(m);
			
			
	    }

}
